ig.module(
	'game.entities.bosshelicopter-iPad'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityBosshelicopterIPad = ig.Entity.extend({
	
	// The players (collision) size is a bit smaller than the animation
	// frames, so we have to move the collision box a bit (offset)
	size: {x: 96, y:88},
	offset: {x:4,y:4},
	maxVel: {x: 64, y: 64},
	type: ig.Entity.TYPE.B, // Player friendly group
	checkAgainst: ig.Entity.TYPE.A,
	collides: ig.Entity.COLLIDES.ACTIVE,	
	animSheet: new ig.AnimationSheet( 'media/gfx/helicopter-iPad.png', 104, 104 ),	
	// These are our own properties. They are not defined in the base
	// ig.Entity class. We just use them internally for the Player
	health: 4000,
	flip: false,
	count: 60,
	dx:0,
	dy:0,
	first: true,
	timer: new ig.Timer(),
	isKill: false,
	
	init: function( x, y, settings ) {
		this.parent( x, y, settings );		
		// Add the animations
		this.addAnim('shooting',0.01,[0,1]);
		this.addAnim( 'die', 0.1, [2] );
		this.addAnim( 'none', 0.1, [2] );
	},
	
	update: function() {				
		// move left or right
		// shoot
		this.dx=ig.game.player_position.x-this.pos.x;
		this.dy=ig.game.player_position.y-this.pos.y;
		
		if(this.first) {
			;
		}else{	
			if(this.count>35)
				this.pos.x-=12;
			else
				this.pos.x+=12;
		}
		if(Math.abs(this.dy)<860 &&this.health>0) {	
			this.count--;
			if (this.count > 0 && this.count < 56 && Math.abs(this.dy) < 860 && this.count % 5 == 0) {
				this.currentAnim = this.anims.shooting;		
				this.currentAnim.flip.x = this.flip;
				ig.game.spawnEntity( EntityHitIPad, this.pos.x+52, this.pos.y+100, {flip:this.flip} );
				ig.game.spawnEntity( EntityHitIPad, this.pos.x+20, this.pos.y+40, {flip:this.flip} );
				ig.game.spawnEntity( EntityHitIPad, this.pos.x+82, this.pos.y+40,{flip:this.flip} );
				ig.game.spawnEntity( EntityEnemyBullet2IPad, this.pos.x+52, this.pos.y+100, {flip:this.flip} );
				ig.game.spawnEntity( EntityJeepBulletIPad, this.pos.x+20, this.pos.y+40, {flip:this.flip} );
				ig.game.spawnEntity( EntityJeepBulletIPad, this.pos.x+82, this.pos.y+40, {flip:this.flip} );
			} else if(this.count==0) {
				this.count=70
				this.currentAnim = this.anims.shooting;		
				this.currentAnim.flip.x = this.flip;
			}else {
				this.currentAnim = this.anims.shooting;		
				this.currentAnim.flip.x = this.flip;
			}
			this.first=false;
		}
		this.currentAnim = this.anims.shooting;		
				this.currentAnim.flip.x = this.flip;
		if(this.health<=0) {
			this.currentAnim = this.anims.none;		
			this.currentAnim.flip.x = this.flip;
		}
		this.parent();
	},
	check: function( other ) {
		if(other.type==ig.Entity.TYPE.BOTH){
			return;
		}	
		other.receiveDamage( 300, this );
	//	this.kill();
	},
	draw: function() {
		this.parent();		
		if(this.health<=0) {
			var font=new ig.Font('media/font-iPad.png');
			font.draw('BOSS', 350,210,ig.Font.ALIGN.CENTER);
			ig.game.spawnEntity( EntityBurstIPad, this.last.x+20, this.last.y, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x, this.last.y+20, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-40, this.last.y, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x, this.last.y-40, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x+20, this.last.y, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x, this.last.y+20, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-40, this.last.y, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-80, this.last.y-40, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x+80, this.last.y, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-80, this.last.y+20, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-40, this.last.y-20, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-60, this.last.y-40, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x+20, this.last.y-60, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-60, this.last.y+20, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-40, this.last.y-60, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x+60, this.last.y-40, {flip:this.flip} );
		}
	},
	
	kill: function() {
		
		if(this.isKill == false) {	
			
			ig.game.spawnEntity( EntityBurstIPad, this.last.x+20, this.last.y, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x, this.last.y+20, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-20, this.last.y, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x, this.last.y-20, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-20, this.last.y, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-20, this.last.y-20, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x+20, this.last.y+20, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x+40, this.last.y, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x, this.last.y+40, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x+40, this.last.y+40, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-40, this.last.y, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x-40, this.last.y-40, {flip:this.flip} );
			ig.game.spawnEntity( EntityBurstIPad, this.last.x, this.last.y-40, {flip:this.flip} );
			
			
			this.isKill = true;
			ig.game.score+=3000;
			this.parent();
			ig.game.spawnEntity( EntityBossIPad, this.last.x, this.last.y + 40, {flip:this.flip} );		
		} else {
			
			if(this.timer.delta() > 0) 
			{	//ig.game.winLevel7=true;
								
			}			
		}
	}
});
});